



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>C语言 文件操作4--文件结构体FILE的理解以及缓冲区再讲</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">C语言 文件操作4--文件结构体FILE的理解以及缓冲区再讲</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-08 07:33:50 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<div>
<pre class="prettyprint linenums">//文件结构体FILE的理解以及缓冲区再讲

#include&lt;stdio.h&gt;<br />
#include&lt;stdlib.h&gt;

//要点：文件结构<br />
//struct _iobuf {<br />
//    char *_ptr;  ------当前缓冲区内容指针<br />
//    int   _cnt;  ------缓冲区还有多少字符<br />
//    char *_base; ------缓冲区的起始地址<br />
//    int   _flag;  ------文件流的状态，是否错误或结束<br />
//    int   _file; -----文件描述符<br />
//    int   _charbuf;  -----双字节缓冲，缓冲2个字节<br />
//    int   _bufsiz;  -----缓冲区大小<br />
//    char *_tmpfname;  -----临时文件名<br />
//};<br />
//typedef struct _iobuf FILE;

void main(){<br />
    //  stdin是键盘文件指针<br />
    char ch;<br />
    printf("缓冲区的有效数据是%d\n", stdin-&gt;_cnt);<br />
    printf("指向缓冲区的指针%x\n", stdin-&gt;_ptr);<br />
    printf("缓冲区的起始地址%x\n", stdin-&gt;_base);<br />
    printf("缓冲区的大小%d\n", stdin-&gt;_bufsiz);<br />
    printf("文件标识符%d\n", stdin-&gt;_file);<br />
    printf("------------\n");<br />
    ch = getchar();<br />
    printf("当前获取的字符是%c\n", ch);<br />
    printf("缓冲区的有效数据是%d\n", stdin-&gt;_cnt);<br />
    printf("指向缓冲区的指针%x\n", stdin-&gt;_ptr);<br />
    printf("缓冲区的起始地址%x\n", stdin-&gt;_base);<br />
    printf("缓冲区的大小%d\n", stdin-&gt;_bufsiz);<br />
    printf("文件标识符%d\n", stdin-&gt;_file);<br />
    //键盘输出123456<br />
    //打印结果：<br />
    //当前获取的字符是1<br />
    //注：getchar()只能获取一个字符，并且将缓冲区内容指针向后移动一个字节（这里ch是char，所以是1个字节，int就会是4个字节）<br />
    //缓冲区的有效数据是6<br />
    //注：这里对缓冲区的有效数据是6作解释，现在缓冲区内实际字符是7个（1，2，3，4，5，6，回车符）<br />
    //因为此时缓冲区内容指针向后移动一个字节，所有有效的就剩下6个<br />
    //指向缓冲区的指针f56c701<br />
    //注：这里ch是char类型，所以缓冲区内容指针向后移动一个字节<br />
    //缓冲区的起始地址f56c700<br />
    //缓冲区的大小4096<br />
    //文件标识符0<br />
    printf("------------\n");<br />
    ch = getchar();<br />
    printf("当前获取的字符是%c\n", ch);<br />
    printf("缓冲区的有效数据是%d\n", stdin-&gt;_cnt);<br />
    printf("指向缓冲区的指针%x\n", stdin-&gt;_ptr);<br />
    printf("缓冲区的起始地址%x\n", stdin-&gt;_base);<br />
    printf("缓冲区的大小%d\n", stdin-&gt;_bufsiz);<br />
    printf("文件标识符%d\n", stdin-&gt;_file);

    printf("------------\n");<br />
    fflush(stdin);<br />
    //fflush()函数的作用是有效数据清零，指针回到起始地址<br />
    //扩展：<br />
    //函数名: fflush<br />
    //功 能 : 清除读写缓冲区，需要立即把输出缓冲区的数据进行物理写入时<br />
    //头文件：stdio.h<br />
    //原型 : int fflush(FILE *stream)<br />
//fflush()函数与stdin-&gt;_cnt = 0;stdin-&gt;_ptr = stdin-&gt;_base;代码等价<br />
    /*stdin-&gt;_cnt = 0;<br />
    stdin-&gt;_ptr = stdin-&gt;_base;*/

    //rewind(stdin);<br />
    //函数名: rewind()<br />
    //功 能 : 将文件内部的位置指针重新指向一个流（数据流 / 文件）的开头<br />
    //注意：不是文件指针而是文件内部的位置指针，随着对文件的读写文件的位置指针（指向当前读写字节）向后移动。而文件指针是指向整个文件，如果不重新赋值文件指针不会改变。<br />
    //rewind函数作用等同于(void)fseek(stream, 0L, SEEK_SET); [1]<br />
    //用 法 : void rewind(FILE *stream);<br />
    //头文件： stdio.h

    //rewind()比fflush()功能更加复杂，rewind()会对文件指针和文件位置指针进行操作，而fflush()主要指针文件位置指针进行操作

    printf("当前获取的字符是%c\n", ch);<br />
    printf("缓冲区的有效数据是%d\n", stdin-&gt;_cnt);<br />
    printf("指向缓冲区的指针%x\n", stdin-&gt;_ptr);<br />
    printf("缓冲区的起始地址%x\n", stdin-&gt;_base);<br />
    printf("缓冲区的大小%d\n", stdin-&gt;_bufsiz);<br />
    printf("文件标识符%d\n", stdin-&gt;_file);<br />
    //打印结果：<br />
    //当前获取的字符是2<br />
    //注：ch是个变量，在内存上有实际地址，清空的只是stdin的缓存，不会影响ch变量<br />
    //缓冲区的有效数据是0<br />
    //指向缓冲区的指针f56c700<br />
    //缓冲区的起始地址f56c700<br />
    //缓冲区的大小4096<br />
    //文件标识符0

    system("pause");<br />
}</pre>
</div>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/644743/201601/644743-20160126150932582-21521793.png" /></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/rql53v68.html">Xcode快捷键</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q73wkx8.html">python获取知乎日报另存为txt文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/r93rjgw9.html">使用Mybatis-Generator自动生成Dao、Model、Mapping相关文件&lpar;转&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q21klx8.html">php读取指定结束指针文件内容</a>
		</li>
						<li><a href="https://www.batexi.com/a/m96egl3q.html">&lbrack;译&rsqb; 二、开始iOS编程之前，你还需要做什么？</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8zmjy19.html">PHP中冒号、endif、endwhile、endfor这些都是什么</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7mm5yeq.html">js仿京东轮播图效果</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwdrymz8.html">C&plus;&plus;：对象指针</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvk1zjq.html">Android studio 下JNI编程实例并生成so库</a>
		</li>
						<li><a href="https://www.batexi.com/a/93xg21r9.html">The usage method of  reference with bibtex in Latex【latex中参考文献的使用方法】</a>
		</li>
						<li><a href="https://www.batexi.com/a/93xly4g9.html">用Android-X86和VirtualBox打造高性能Android开发环境</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wn4woq.html">linux ERROR&colon; ld&period;so&colon; object &apos;&sol;lib&sol;libcwait&period;so&apos; from &sol;etc&sol;ld&period;so&period;preload cannot be preloaded&colon; ignored&period;</a>
		</li>
						<li><a href="https://www.batexi.com/a/90mdk7m8.html">laravel使用多个数据库连接</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ojle3lq.html">vagrant扩容</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1lrzoq.html">Shell中数组的使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4jz2d5q.html">c&num;&colon; WebBrowser 禁止在新窗口打开链接</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j11wee9.html">&lowbar;&lowbar;&lowbar;&lowbar;利用C&num;特性Attribute完成对sql语句的拼接</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o1w41eq.html">IDEA下搜狗输入法输入中文时卡着不动的参考解决方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxdjo6d9.html">一些日常工具集合（C&plus;&plus;代码片段）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j1w4y49.html">2017-2018-2 20165315 实验三《敏捷开发与XP实践》实验报告</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/49goke0q.html">JSP内置对象--request对象</a>
			</li>
						<li><a href="https://www.batexi.com/a/m96vk3j8.html">【转】牛人整理分享的面试知识：操作系统、计算机网络、设计模式、Linux编程，数据结构总结</a>
			</li>
						<li><a href="https://www.batexi.com/a/3906no49.html">block做方法参数时--block的参数传值过程 例1</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9pl667q.html">java 接口（interface）</a>
			</li>
						<li><a href="https://www.batexi.com/a/jqd7177q.html">开始玩mondrian</a>
			</li>
						<li><a href="https://www.batexi.com/a/wq11xpzq.html">Linux套接字编程</a>
			</li>
						<li><a href="https://www.batexi.com/a/jqd7y50q.html">【php】使用phpdbg来调试php程序</a>
			</li>
						<li><a href="https://www.batexi.com/a/jqd72rjq.html">Spring学习笔记之 Spring IOC容器&lpar;二&rpar; 之注入参数值，自动组件扫描方式，控制Bean实例化方式，使用注解方式</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qyzzvg9.html">数据结构--线段树--lazy延迟操作</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qyzzoj9.html">JavaScript 题目破解过程与解析</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
